export default function applyTransform() {
  let maxTransX, maxTransY, minTransX, minTransY

  if (this.defaultWidth * this.scale <= this.width) {
    maxTransX = (this.width - this.defaultWidth * this.scale) / (2 * this.scale)
    minTransX = (this.width - this.defaultWidth * this.scale) / (2 * this.scale)
  } else {
    maxTransX = 0
    minTransX = (this.width - this.defaultWidth * this.scale) / this.scale
  }

  if (this.defaultHeight * this.scale <= this.height) {
    maxTransY = (this.height - this.defaultHeight * this.scale) / (2 * this.scale)
    minTransY = (this.height - this.defaultHeight * this.scale) / (2 * this.scale)
  } else {
    maxTransY = 0
    minTransY = (this.height - this.defaultHeight * this.scale) / this.scale
  }

  if (this.transY > maxTransY) {
    this.transY = maxTransY
  } else if (this.transY < minTransY) {
    this.transY = minTransY
  }

  if (this.transX > maxTransX) {
    this.transX = maxTransX
  } else if (this.transX < minTransX) {
    this.transX = minTransX
  }

  this.canvas.applyTransformParams(this.scale, this.transX, this.transY)
 
  if (this.markers) {
    this.repositionMarkers()
  }

  if (this.lines) {
    this.repositionLines()
  }

  this.repositionLabels()
}
